/* tk_vars.c
 */
#include "lisp.h"
#include <tcl.h>
/*
*   TK global vars & ss 
*   communication test
*/

extern Tcl_Interp *myInterp;

ptr s_tclsetvar(int narg,ptr env){
  ptr var=*(stack-2),val=*(stack-1); 
  Uchar *p,*q;
  Uint n;
   checknarg(narg-2);
  if(SREGP(var)||!STRINGP(var)) error(E_notstr,var);
  if(SREGP(val)||!STRINGP(val)) error(E_notstr,val);
   p=get_string(var,&n);
   q=get_string(val,&n);
   p=(Uchar *)Tcl_SetVar(myInterp, (char *)p, (char *)q, TCL_GLOBAL_ONLY);
   if(p==NULL){
      /*** printf("error in TCL\n");***/
      lwritestr(STDERR,"error in TCL\n");
   }
   return a_undef;
}

ptr s_tclgetvar(int narg,ptr env){
  ptr var=*(stack-1),val;
  char *p,*q;
  Uint n;
   checknarg(narg-1);
  if(SREGP(var)||!STRINGP(var)) error(E_notstr,var);
   p=(char *)get_string(var,&n);
   q=(char *)Tcl_GetVar(myInterp, p,  TCL_GLOBAL_ONLY);
     if(q==NULL){
      /** printf("error in TCL \n"); ***/
      lwritestr(STDERR,"error in TCL \n");
      return a_undef;
   }
   val=make_str_c(q);
   return val;
}


