;;;   http-que.ss
;;;  DL-manager
;;;;
(in-package "http")

(define (DL-stop)
   (set! *DL-stop* #t)
)
;;;;

(define (remove-que dld)
 (let* ((x 0))
  (set! *DL-accept* #f)
  (set! *DL-que* (remove dld *DL-que*))
  (set! *DL-accept* #t)
  dld
))

(define (start-que dld)    ;;; for binary
  (set! *DL-accept* #f)
   (DL-win-out  dld 0 0  'QUE  )
   (set-DLD dld :proxy *Proxy*)
   (set! *DL-accept* #t)
   (DL-manager dld  #f)
)

(define (restart-que dld)
  (let* ((bin (DLD-binary dld)))
    (set! *DL-accept* #f)
   (set-DLD dld :ishtml (not bin))   ;;;;  need this 
   (DL-win-out  dld 0 0  'QUE  )
   (set-DLD dld :proxy *Proxy*)
   (push dld *DL-que*)
   (set! *DL-accept* #t)
    (if (not *DL-active*) (DL-manager #f  #f))
))

(define (DL-force dld)
  (set! *DL-accept* #f)
   (DL-win-out  dld 0 0  'ACT  )
   (set-DLD dld :proxy *Proxy*)
   (http-request dld )
   (set! *DL-accept* #t)
)


(define (DL-manager dld force)
   ;;;(format #t "DL-manager req ~s~%" req)
   (if dld
      (if force
         (begin
             (http-request dld )
         )
         (begin
            ;;;(push req *DL-que*)
            (set!  *DL-accept* #f)
            (DL-win-out  dld  0 0  'QUE )
            (set! *DL-que* (append *DL-que* (list dld)))
            (set!  *DL-accept* #t)
            (when (not *DL-active*)
                 (DL-manager #f  #f)
            )
          )
       )
      ;;; else
       (begin
            (set! *DL-active* #t)
          (if (>= *DL-num* *DL-MAX*)
             (after 1000 (lambda () (DL-manager #f  #f)))
            (if (and (not *DL-stop*) *DL-accept* (pair? *DL-que*))
                  (begin
                   (set! dld (pop *DL-que*))
                   (http-request  dld )  
                    (after 1000 (lambda () (DL-manager #f  #f)))
                  )
                (if (and (not *DL-stop*) (pair? *DL-que*))
                    (after 1000 (lambda () (DL-manager #f  #f)))
                    (set! *DL-active* #f)
                )
             )
           )
       )
    )
)

