(define g (lambda(x)
       (syntax-case x ()
        ((_) (syntax #f))
        ((_ x) (syntax x))
        ((_ x y ...) (syntax (let* ((t x)) (if t t (or y ...)))))
      )
  )
)

(g '(or x t))    ;;;; OK!
;;;
(define h (lambda(x)
       (syntax-case x ()
           ((_ x ...) (syntax (begin (do (test x) (print x)) ... )))
        )
))

(h '(or u x z))
    ;;;; Not work!
;;;;
(let-syntax ((when (syntax-rules ()
                      ((when test stmt1 stmt2 ...)
                        (if test (begin stmt1 stmt2 ...))))))
   (let* ((if #t))
     (when if (set! if 'now))
     if))
;;;   let   ----  mada
(let* ((x 'outer))
  (let-syntax ((m (syntax-rules () ((m) x))))
     (let* ((x 'inner))
        (m))))
;;;;  outer

(let* ()
  (let-syntax 
      ((def (syntax-rules ()
                ((def stuff ...) (define stuff ...)))))
       (def foo  42))
     foo)
;;;;  No good!   ss2.0 unrecognize define  in let*-block
;;;;  OK  vm_comp.c を修正。
;;;;    42

(let* ()
   (let-syntax ())
   5)
;;;  OK
(define-macro (setf  .  x)
  (syntax-case  x ()
     (((s v) val)  (eq? (syntax s)  'car)  (syntax (set-car! v  val)))
     (((s v) val)  (eq? (syntax s)  'cdr)  (syntax (set-cdr! v  val)))
     (((s x i) val) (eq? (syntax s) 'vector-ref )  (syntax (vector-set! x i val)))
  )
)
;;;P.186
(let* ((f (lambda(x) (+ x 1))))
  (let-syntax ((f (syntax-rules ()
                      ((_ x) x)))
               (g (syntax-rules ()
                      ((_ x) (f x)))))
          (list (f 1)(g 1)))
)

(let* ((f (lambda(x) (+ x 1))))
  (letrec-syntax ((f (syntax-rules ()
                      ((_ x) x)))
               (g (syntax-rules ()
                      ((_ x) (f x)))))
          (list (f 1)(g 1)))
)

