
(in-package "debug")

(define (do-debug msg env)
   (if msg (format #t "debug: ~a~%" msg))
   (do ((x 0))
       ((eq? x :q))
       (display "debug>> ")
       (flush)
       (set! x (read))
       (format #t "~s~%" (eval x env))
   )
)

(define-syntax debug
   (syntax-rules (interaction-environment)
     ((debug) (do-debug #f (interaction-environment)))
     ((debug msg) (do-debug msg (interaction-environment)))
     ((debug msg env) (do-debug msg env))
   )
)
(export 'debug)
(use-package "debug" "ss")


