;; renketu ten wo siraberu
;;;
;;;  for test
(define *ren-do-all* 0)   ;;; renketu-do  base-data
(define *kuro-ren* 0)   ;;; kuro renketu ten
(define *shiro-ren* 0)  ;;; shiro renketu ten
;;; (define *2-ren* 0)   ;;; renketu base-data
;;;;    black no subete no renketu ten wo motomeru
;;;;    ((1.5 te b1 b2 ...)  (1.0 te2 b3 b4 ....) ......)
;;;;;    saisyo ha renketu-do  wo arawasu
;;;;   
;;;;    b1 b2 ....   ha  te ni yotte renketu sareru block
;;;;;      
(define (renketu-do  b w)
 (let ((kouho 0) (blist 0) (res ()) (ren 0)  )
   (set! *empty* (get-empty b w))
   (set! kouho (logx-y (dame-of  b) w))
   (set! blist (block-list b))
   (do ((x 0) (bk 0) (d 0))
       ((= 0 kouho))
       (set! x (1-te kouho))
       (set! kouho (logxor x kouho))
       (set!  d (logcount (s-dame x b)))
       ;(format #t "~s " d)
       ;(prgo x b)
       ;(wait-return)
       (when (< d 3)   ;;; d=3 is not renketu
          (set! bk (logxor x (gen-block x b)))
          (if (member bk blist)
               ()
             (push (renketu-do-sub  x  bk blist b w) res)
          )
       )
   )
   (set! *ren-do-all* res)
  ; (set! ren  (2-renketu blist res))
  ; (group-list blist ren)
   res
))
;;;;    safe-te   is   in sityo.scm
;;;;;
(define (renketu-do-sub te bk blist b w)
  (do ((x 0) (res ()))
      ( (null? blist) (cons (eval-ren-do  te b w) (cons te res))) 
    (set! x (pop blist))
    (if (= x (logand bk x)) (push x res))
 )
)
(define (eval-ren-do  te b w)
   (let ((d 0))
     (set! te (1-grow te))
     (set! b (logand b  te))
     (set! b (logcount b))
     (set! w (logand w  te))
     (if (= w 0)
        (+ 1.0 (* 0.25  b))
        (+ 0.5 (* 0.25 (- b (logcount w))))
     )
))
;;;;
;;;; *ren-do-all* yori   level  ijou    no  ren-list  wo tukuru
;;;;  ((2.0  te 2 3 4)(1.0  te 4 5))
;;;;  ->   ((2 3 )(2 4) ( 3 4) (4 5))   (if level==1.0)
(define (make-ren-level  level)
  (let ((ren *ren-do-all*) (res ()))
    (do ((x 0))
        ((null? ren) res)
        (set! x (pop ren))
       (when (>= (pop  x) level)   ;;;; x is safe
           (pop x);;;  take off te
           (do ((g 0))
               ((null? x))
               (set! g (pop x))
               (set! res (ren-expand g x res))
           )
       )
     )
))
;;;  in renketu.scm (define (ren-expand b blist res)
;;;;;;    2-ren list wo tukuru
(define (make-2-do-ren level)
   (let ((ren *ren-do-all*) (res ()))
    (do ((x 0))
        ((null? ren) res)
        (set! x (pop ren))
       (when (< (pop  x) level)    ;;;; x is not safe 
           (pop x);;;  take off te
           (do ((g 0))
               ((null? x))
               (set! g (pop x))
               (set! res (ren-expand g x res))
           )
       )
     )
  (2ren-select res)
))
;;;   (define (2ren-select ren)   in renketu.scm
               
;;;;test
;;;;;  maximamu group
(define (group-do level)
  (let ((blist 0)(wlist 0)(b 0)(w 0)(ren ())(bgroup 0)(wgroup 0) )
    (set! b (car *b-history*))
    (set! w (car *w-history*))
    (set! ren (renketu-do b w))
    (set! ren (make-all-ren ren))
    (set! blist (block-list b))
    (set! bgroup (g-list-2 (group-wake blist ren)) )
    (set! ren (renketu w b ))
    (set! ren (make-all-ren ren))
    (set! blist (block-list w))
    (set! wgroup (g-list-2 (group-wake blist ren)) )
    (prgui bgroup  wgroup)
))    

;;;;  safe & 2-ren niyoru group wake

(define (group-do2 level)
  (let ((bg 0)(wg 0))
     (set! bg (car *b-history*))
     (set! wg (car *w-history*))

    (set2! bg wg (group-do-list bg wg level))
    (prgui bg  wg)
))
(define (group-do-list b w level)
  (let ((blist 0)(wlist 0)(ren ())(bgroup 0)(wgroup 0) )
    ;(set! b (car *b-history*))
    ;(set! w (car *w-history*))
    (set! ren (renketu-do  b w))
    (set! *kuro-ren* (renketuten ren))
    (set! ren (make-ren-level level))
    (set! ren (append ren (make-2-do-ren level)))
    (set! blist (block-list b))
    (set! bgroup (g-list-2 (group-wake blist ren)) )
    (set! ren (renketu-do  w b ))
    (set! *shiro-ren* (renketuten ren))
    
    (set! ren (make-ren-level level))
    (set! ren (append ren (make-2-do-ren level)))
    (set! blist (block-list w))
    (set! wgroup (g-list-2 (group-wake blist ren)) )
    (cons  bgroup  wgroup)
))    

(define (renketuten ren)
  (let ((res () ))
    (do ((x 0))
       ((null? ren)res)
       (set! x (pop ren))
       (push (cadr x) res)
    )
))
