;;;  ŻҲ   multi-client server
;;;  2004.7.16
;;;;  when-socket-ready  version

(define net (netport 50000))
(define listen-soc (socket-listen net))
(define *n* 0)
(define *clients* ())

(define (read-start name acc person)
  (when-socket-ready acc
    (lambda ()
       (let* ((msg 0))
           (set! msg (read-line acc))
              (if (eof-object? msg)
                (begin
                  (close-port acc)   ;;; this member is out!
                  (set! *clients* (remove person *clients*))
                  (dec *n*)
                  (when-socket-ready acc #f)  ;;;; cancel waiting
                 )
                (begin
                  (send-msg msg name (remove person *clients*)) ;;; send for others
                  (format #t "recv: from ~a > ~a ~%" name msg) ;;; display msg on server scr
                )
             )
       )
    )
  )
)

(define (send-msg msg name others)
   (while (pair? others)
       (format (cdr (pop others)) "~a>> ~a~%" name  msg)
   )
)

;;;; start accept !!
(when-socket-ready listen-soc
    (lambda ()
       (let* ((acc 0)(name 0))
         (set! acc (socket-accept listen-soc)) ;;; accept client
         (inc *n*)
         (set! name (read-line acc))
        (format acc "Welcome you are ~s st member~%" *n*)
         (if (= *n* 1)
            (format acc " Please Wait~%" name)  ;;; Only One
            (send-msg  "Hello!" name *clients*)  ;;; greeting for others
         )
         (push (cons name acc) *clients*)
         (format acc "Now members are ~s~%" (map car *clients*))
         (read-start name acc (cons name acc))
       )
    )
)
;;;;  you can stop server  by the following
(define (server-off) 
    (when-socket-ready listen-soc #f)
    (map (lambda(x) (close-port (cdr x))) *clients*)
    (close-port listen-soc)
    (set! *clients* ())
)
