;; 2020.1.4
;; experiment write_circle
;;
(define marks ())  ;;; setmark
(define circle-list ())
(define circle-list-first ())
(define nc 0)
;;  circle check
(define (mark x)
     (push x  marks) 
)

(define (cc x)
    (set! circle-list ())
    (set! circle-list-first ())
    (cc-aux x)
    (clear-mark x)
    (set! nc 0)
    (if (pair? marks)
        (display "Abnormal!!!")
    )
)

(define (cc-aux x)
  (let* ((as #f))
     (set! as (member x marks))
     (if as
         (begin
           (push (cons x nc) circle-list)
           (inc nc)
         )
        (begin
          (if (pair? x)
            (begin
               (mark x) 
               (cc-aux (car x))
               (cc-aux (cdr x))
            )
           (if (vector? x)
             (cc-vec x)
           )
         )
        )
    )
))

(define (clear-mark x)
   (when (member x marks)
         (set! marks (remove x marks))
       (if (pair? x)
            (begin
               (clear-mark (car x))
               (clear-mark (cdr x))
            )
           (if (vector? x)
             (clear-vec x)
           )
       )
    )
 )

(define (clear-vec x)
   (let* ((s (vector-size x)))
     (do ((i 0(+ i 1)))
         ((= i s))
        (clear-mark (vector-ref x i))
     )
))


(define (cc-vec x)
   (let* ((s (vector-size x)))
       (mark x) 
     (do ((i 0(+ i 1)))
         ((= i s))
        (cc-aux (vector-ref x i))
     )
))

;;;

(define (circle-first? x)
  (let* ((as 0))
      (set!  as (assq x circle-list))
      (if as
         (if (member x circle-list-first)
               (cdr as)
              (begin
                (push  x circle-list-first)
               as    ;;;first apper
              )
         )
         #f
      )
))


;;;;;;;;;;;;;;;;
(define (cp x)
   (cc x)
   (if (pair? circle-list)
      (docp x)
      (write x)   ;;;  pure 
   )
)

(define lp #\( )
(define rp #\) )

(define (docp x)
  (let* ((as 0)(cont #t))
         (set! as (circle-first? x))
         (if as
           (if (pair? as)
             (begin
               (format #t "#=~a" (cdr as))
             )
             (begin
              (format #t "#-~a" as )
              (set! cont #f)
             )
           )
         )
     (when  cont
         (if (or (vector? x)(pair? x))
           (begin
             (if (vector? x) (display #\#))
             (display lp)
             (if (pair? x)
                (docp-list x)
                (docp-vec x)
             )
             (display rp)

            ) 
           (write x)
         )
    )
))


(define (docp-list x)
  (let* ((as 0)(circ #f))
    (when (pair? x)
       (docp (pop x))
       (display #\space)
       (set! as (circle-first? x))
       (if as
          (if (pair? as)
             (begin
              (format #t " . #=~a" (cdr as))
               (display lp)
               (docp-list x)
               (display rp)
             )
             (begin
              (format #t " . #-~a" as)
             )
           )
         (docp-list  x)
      )
    )
   ;(display rp)
))

(define (docp-vec x)
   (let* ((s (vector-size x)))
     (do ((i 0(+ i 1)))
         ((= i s))
        (docp  (vector-ref x i))
       (display #\space)
     )
))


;; example
  (define b '(1))
  (define a (cons 'A b))
  (set-cdr! b a)
  (set!  b '(1))
  (define c (cons 'C b))
  (set-car! b c)
  (define d (cons 'D a))
  (define x #(1 2 3))
  (vector-set! x 0 x)
  (vector-set! x 2 a)
(define (test)  
  (cp a)
  (newline)
  (cp c)
  (newline)
  (cp x)
  (newline)
)
       



