/****  genmatheq.c   ***/
/****  lsubr =, < etc.  ***/
#include "lisp.h"
extern void checknarg();

extern int  gen_order(),gen_eq();

/***  expand lsubr and predicate function to expr2 ***/
/***  nrag must >=2  ***/
ptr expand2pred(narg,fun)     
    Reg int narg;
    Reg ptr (* fun)();
 {
    register ptr q,*sfree=stack-narg,r;
    
    q=*sfree++;
    narg--;
    /** if(NOT_NUMBERP(q)) error(E_notnum,q); ***/
    if(!NUMBERP(q)) error(E_notnum,q);
    while(narg--)
      {
       r=*sfree++;
    /*** if(NOT_NUMBERP(r)) error(E_notnum,r); ***/
    if(!NUMBERP(r)) error(E_notnum,r);
       q=(* fun)(q,r);
       if(q==a_f) return q;
       q=r;
      }
    return a_t;
 }

ptr g2_eq(ptr x, ptr y)
                                                                                          
 {
  return gen_eq(x,y)?a_t:a_f;
 }

ptr g2_lt(ptr x, ptr y)
                                                                                          
 {
  return (gen_order(x,y)<0)?a_t:a_f;
 }

ptr g2_gt(ptr x, ptr y)
                                                                                          
 {
  return (gen_order(x,y)>0)?a_t:a_f;
 }

ptr g2_le(ptr x, ptr y)
                                                                                          
 {
  return (gen_order(x,y)<=0)?a_t:a_f;
 }
                                                                                          
ptr g2_ge(ptr x, ptr y)
                                                                                          
 {
  return (gen_order(x,y)>=0)?a_t:a_f;
 }


ptr s_g_lt(int narg,ptr env)     /*  subr  */
 {
    if(narg<2)  checknarg(narg-2);
    return expand2pred(narg,g2_lt);
 }

ptr s_g_le(int narg,ptr env)     /*  subr  */
 {
    if(narg<2)  checknarg(narg-2);
    return expand2pred(narg,g2_le);
 }

ptr s_g_eq(int narg,ptr env)     /*  subr  */
 {
    if(narg<2)  checknarg(narg-2);
    return expand2pred(narg,g2_eq);
 }

ptr s_g_gt(int narg,ptr env)     /*  subr  */
 {
    if(narg<2)  checknarg(narg-2);
    return expand2pred(narg,g2_gt);
 }
                                                                                          
ptr s_g_ge(int narg,ptr env)     /*  subr  */
 {
    if(narg<2)  checknarg(narg-2);
    return expand2pred(narg,g2_ge);
 }

 
