/*** random.c
    sslisp  03.09.16 
     2019.10.10   MT
***/
#include  "lisp.h"
extern int xhash();   /*** hash.c ***/
extern void mt_seed(int);
extern double urand(void);
extern int nrand(int);
  
ptr s_make_mtrandom(int narg,ptr env)
 {
    /*   expr 1  */
    Reg ptr x=*(stack-1);
   mt_seed(xhash(x));/*** maybe danger **/ 
   return a_undef;
 }
 
ptr s_mtrandom(int narg,ptr env)
 {
    ptr p;
    double s;
    unsigned long int n;
    if(narg==0) p=a_nil;
    else if(narg==1)
        p=*(stack-1);
    else
          checknarg(narg-1);
    /*** if(gsign(p)||zerop(p)) error(E_range,p); **/
    
    if(SINTP(p))
      {
         if(p==ZERO) error(E_range,p);
         n=nrand(GETNUM(p));
         return MAKESINT(n);
      }
    else if(p==a_nil)
      { 
         s=urand();
        return MAKEDBL(s);
       }
    else
       return error(E_typemis,p);
 }
