;;;;  g-mode
;;;; Ver 2.2
;;;; 2005.8.29
;;;
(in-package "regexp")

(define (set-g-mode mode)
   (cond ((eq? mode :nocase)
              (set! regexp-char=?  char-ci=?)
             )
         ((eq? mode :case)
              (set! regexp-char=?  eq?)
             )
          ((or (eq? mode :single) (eq? mode :multiple))
               (set! *regexp-mode* mode)
             )
           ((eq? mode :normal)
              (set! regexp-char=?  eq?)
              (set! *regexp-mode* #f)
             )
           (else (error 409 mode))
    )
)



