;;;;  R-shift.ss
;;;;    For speed up
;;;;
(in-package "regexp")

(define (R-shift-top i)
   (if (eq? i 0) 
         0
      (if (eq? *regexp-mode* :multiple)
         (let* ((ans #f))
           (while (and (not ans) (< i *regexp-length*) )
                (if (eq? (R-string-ref i ) #\newline)
                    (set! ans (+ i 1))
                    (inc i)
                 )
            )
           ans
         )
        #f
     )
   )
)

(define (R-shift-end i)
   (if (eq? i *regexp-length*)
         i
      (let* ((ans #f))
           (while (and (not ans) (< i *regexp-length*) )
                (if (eq? (R-string-ref i ) #\newline)
                    (set! ans  i )
                    (inc i)
                 )
            )
          (if ans
                ans
               *regexp-length*
          )
       )
   )
)

(define (R-shift-G-pos i)
   (if (<= i *G-pos*) 
          *G-pos*
         #f
    )
)

(define (R-shift-g-pos i)
   ;;;;(format #t "g-pos ~s ~s~%" i *G-pos*)
   (if (<= i *G-pos*)
          *G-pos*
         i
    )
)

(define (R-shift-abs-end i)
     *regexp-length*
)

(define (L-shift-end i ma)
  (let* ((e (- *regexp-length* ma))(memo i))
   (if (>= i e)
         i
      (let* ((ans #f))
           (while (and (not ans) (< i *regexp-length*) )
                (if (eq? (R-string-ref i ) #\newline)
                    (set! ans  i )
                    (inc i)
                 )
            )
          (if ans
              (begin
                 (set! e (- ans ma))
                 (if (>=  memo e) memo e)
              )
              e
          )
       )
   )
))

(define (L-shift-abs-end i ma)
  (let* ((e (- *regexp-length* ma))(memo i))
   (if (>= i e)
         i
         e
   )
))

(define (R-shift-str i str)
  (R-search-str str i)
)


      
  
