;;;; unix->dos SJIS
;;;;  Caution!!!    All files changed  !!!
;;;;  2010.6.20
;;;; euc->utf8
;;;;

(define  (dos2unix-LF file)
   (let* ((temp (make-temp-file)))
       (system (tk-string "tr -d \\\\r<" file ">" temp))
       (system (tk-string "mv " temp " " file))
   )
)
(define  (unix2dos-CRLF file)
   (let* ((temp (make-temp-file)))
     (system (tk-string "perl -p -e 's/\\n/\\r\\n'<"
        file ">" temp))
       (system (tk-string "mv " temp " " file))
))
 

(define (unix2dos code . files)
     (foreach file files
       (unix2dos-CRLFystem  file)
       (kconv-file file file :sjis code)
    )
)

(define (unix2dos-all   code)
  (let* ((files (glob "*")) (ans 0))
  (format #t "This changes ALL files to dos & sjis file~%")
  (format #t "Are you sure?(y/n)")
  (flush)
  (set! ans (read))
  (if (eq? ans 'y)
      (apply unix2dos code files) 
  )
))

(define (dos2unix code . files)
     (foreach file files
        (dos2unix-LF file)
       ( kconv-file file file code :sjis )
    )
)

(define (dos2unix-all code)
  (let* ((files (glob "*")) (ans 0))
  (format #t "This changes ALL files to unix file~%")
  (format #t "Are you sure?(y/n)")
  (flush)
  (set! ans (read))
  (if (eq? ans 'y)
      (apply dos2unix code files) 
  )
))

(define (euc-utf8-all)
  (let* ((files (glob "*")) (ans 0))
  (format #t "This changes ALL euc files to utf8~%")
  (format #t "Are you sure?(y/n)")
  (flush)
  (set! ans (read))
  (if (eq? ans 'y)
     (foreach file files
       ( kconv-file file file :utf8 :euc )
     )
  )
))

(define (utf8-euc-all)
  (let* ((files (glob "*")) (ans 0))
  (format #t "This changes ALL utf8 files to euc file~%")
  (format #t "Are you sure?(y/n)")
  (flush)
  (set! ans (read))
  (if (eq? ans 'y)
     (foreach file files
       ( kconv-file file file :euc :utf8 )
     )
  )
))



   
