;; renketu ten wo siraberu
;;;
;;;  for test
(define *ren-all* 0)   ;;; renketu base-data
(define *2-ren* 0)   ;;; renketu base-data

;;; ((te  b1 b2 ...) ....)
;;;  te connects block b1 b2 ...
;;;

(define (pr-group )
   (let ((b 0)(w 0)(blis 0) (wlis 0))
      (set! b (car *b-history*))
      (set! w (car *w-history*))
     (set! blis (g-list  b w))
     (set! wlis (g-list   w b))
     (prgui blis wlis)
))
(define (pr-block )
   (let ((b 0)(w 0)(blis 0) (wlis 0))
      (set! b (car *b-history*))
      (set! w (car *w-history*))
     (set! blis (block-list  b ))
     (set! wlis (block-list   w ))
     (prgui blis wlis)
))
(define (pr-m-block )
   (let ((b 0)(w 0)(blis 0) (wlis 0))
      (set! b (car *b-history*))
      (set! w (car *w-history*))
     (set! blis (block-list (logx-y (1-grow b)w) ))
     (set! wlis (block-list (logx-y (1-grow w)b) ))
     (prgui blis wlis)
))

(define (list-sub lis1 lis2)
   (do ((x 0))
       ((null? lis2) lis1)
       (set! x (pop lis2))
       (set! lis1 (remove x lis1))
    )
)
(define (member-nil x list)
 (let ((x 0))
   (set! x (member x list))
   (if x (remove x list)
       ()
   )
))
;;;;    ((#t te b1 b2 ...)  (#f te2 b3 b4 ....) ......)
;;;;;    te ha renketu ten
;;;;    #t ha anzen na renketu ten
;;;;    b1 b2 ....   ha  te ni yotte renketu sareru block
;;;;;      
(define (renketu b w)
 (let ((kouho 0) (blist 0) (res ()) (ren 0)  )
   (set! *empty* (get-empty b w))
   (set! kouho (logx-y (dame-of  b) w))
   (set! blist (block-list b))
   (do ((x 0) (bk 0) (d 0))
       ((= 0 kouho))
       (set! x (1-te kouho))
       (set! kouho (logxor x kouho))
       (set!  d (logcount (s-dame x b)))
       ;(format #t "~s " d)
       ;(prgo x b)
       ;(wait-return)
       (when (< d 3)   ;;; d=3 is not renketu
          (set! bk (logxor x (gen-block x b)))
          (if (member bk blist)
               ()
             (push (renketu-sub  x  bk blist b w) res)
          )
       )
   )
   (set! *ren-all* res)
  ; (set! ren  (2-renketu blist res))
  ; (group-list blist ren)
   res
))
;;;;    safe-te   is   in sityo.scm
;;;;;
(define (renketu-sub te bk blist b w)
  (do ((x 0) (res ()))
      ( (null? blist) (cons (safe-bt te b w) (cons te res))) 
    (set! x (pop blist))
    (if (= x (logand bk x)) (push x res))
 )
)

;;;;  ren-all yori ,  subete!!! no ren wo tukuru
;;;;    this is possible maximam group  ren
;;;;
(define (make-all-ren ren)
  (let ( (res ()))
    (do ((x 0))
        ((null? ren) res)
        (set! x (pop ren))
           (pop  x)   ;;;; take-off  safe-flag 
           (pop x);;;  take off te
           (do ((g 0))
               ((null? x))
               (set! g (pop x))
               (set! res (ren-expand g x res))
           )
     )
))


;;;; *ren-all* yori safe   no  ren-list  wo tukuru
;;;;  ((#t te 2 3 4)(#t te 4 5))
;;;;  ->   ((2 3 )(2 4) ( 3 4) (4 5))
(define (make-safe-ren)
  (let ((ren *ren-all*) (res ()))
    (do ((x 0))
        ((null? ren) res)
        (set! x (pop ren))
       (when (pop  x)   ;;;; x is #t=safe
           (pop x);;;  take off te
           (do ((g 0))
               ((null? x))
               (set! g (pop x))
               (set! res (ren-expand g x res))
           )
       )
     )
))
(define (ren-expand b blist res)
  (do ((x 0))
      ((null? blist) res)
      (push (list b (pop blist)) res)
  )
)
;;;;;;    2-ren list wo tukuru
(define (make-2-ren)
   (let ((ren *ren-all*) (res ()))
    (do ((x 0))
        ((null? ren) res)
        (set! x (pop ren))
       (when (not (pop  x))    ;;;; x is not safe 
           (pop x);;;  take off te
           (do ((g 0))
               ((null? x))
               (set! g (pop x))
               (set! res (ren-expand g x res))
           )
       )
     )
  (2ren-select res)
))
(define (2ren-select ren)
  (let ((res ()))
      (set! ren (seiretu ren))
    (do ((x 0))
        ((null? ren) res)
        (set! x (pop ren))
        (when  (member x ren)   ;;;  x is in ren >=2 times
             (set! ren (remove x ren))
             (push x res)
        )
     )
))
(define (seiretu ren)
  (do ((x 0)(res ()))
      ((null? ren ) res)
      (set! x (pop ren))
      (if (> (car x) (cadr x))
          (set! x (list (cadr x) (car x)))
      )
     (push x res)
 ))
   
(define (group-wake blist ren)
  (let ((res ()))
    (set! ren (seiretu ren))
    (set! res  (barabara blist ))
    (group-up res ren)
))
(define (group-up res ren)    ;;;; input res is group-list(incomplete)
                              ;;;;  out complete group-list
    (do ((x 0)(p 0)(q 0)(sp 0)(sq 0))
        ((null? ren) res)
      (set! x (pop ren))
       (set! p (car x))
       (set! q (cadr x))
       (set! sp (find-in-g p res))
       (set! sq (find-in-g q res))
       (if (equal?  sp sq)
              ()
           (begin
               (set! res (remove sp res))
               (set! res (remove sq res))
               (push (append sp sq) res)
           )
       )
))

;;;  group wake no motono katati wo tukuru
;;;;    tanjun  ni barabara    ((b1)(b2).....)
(define (barabara blist)
  (map (lambda (x) (cons x ())) blist))

          
          
(define (find-in-g p g-list)
  (do ((x 0)(res #f))
      ((or res (null? g-list))  res)
      (set! x (pop g-list))
      (if (member p x)
            (set! res x))
))
               
;;;;test
;;;;;  maximamu group
(define (group)
  (let ((blist 0)(wlist 0)(b 0)(w 0)(ren ())(bgroup 0)(wgroup 0) )
    (set! b (car *b-history*))
    (set! w (car *w-history*))
    (set! ren (renketu b w))
    (set! ren (make-all-ren ren))
    (set! blist (block-list b))
    (set! bgroup (g-list-2 (group-wake blist ren)) )
    (set! ren (renketu w b ))
    (set! ren (make-all-ren ren))
    (set! blist (block-list w))
    (set! wgroup (g-list-2 (group-wake blist ren)) )
    (prgui bgroup  wgroup)
))    

;;;;  safe & 2-ren niyoru group wake

(define (group2)
  (let ((bg 0)(wg 0)(val 0))
     (set! bg (car *b-history*))
     (set! wg (car *w-history*))

    ;;;(set2! bg wg (group-list bg wg))
    (set! val (group-list bg wg))
    (set! bg  (car val))
    (set! wg  (cdr val))
    (prgui bg  wg)
))
(define (group-list b w)
  (let ((blist 0)(wlist 0)(ren ())(bgroup 0)(wgroup 0) )
    ;(set! b (car *b-history*))
    ;(set! w (car *w-history*))
    (renketu b w)
    (set! ren (make-safe-ren))
    (set! ren (append ren (make-2-ren)))
    (set! blist (block-list b))
    (set! bgroup (g-list-2 (group-wake blist ren)) )
    (renketu w b )
    (set! ren (make-safe-ren))
    (set! ren (append ren (make-2-ren)))
    (set! blist (block-list w))
    (set! wgroup (g-list-2 (group-wake blist ren)) )
    (cons  bgroup  wgroup)
))    

(define (g-list-2 g-list)
  (do ((res ()) ( x 0))
      ((null? g-list) res)
      (set! x (pop g-list))
      (push (eval `(logior ,@x)) res)
))
